FreeUI = { 
	["backdrop"] = "Interface\\ChatFrame\\ChatFrameBackground", -- default backdrop
	["font"] = "Interface\\AddOns\\!freeUI\\media\\Hooge0655.ttf", -- default pixel font
	["font2"] = "Interface\\AddOns\\!freeUI\\media\\SFPixelate.ttf", -- quest tracker font
	["font3"] = "Interface\\AddOns\\!freeUI\\media\\Enigma__2.ttf", -- chat frame font
	["glow"] = "Interface\\AddOns\\!FreeUI\\media\\glowTex", -- glow/shadow texture
	["low_health"] = "Interface\\AddOns\\!FreeUI\\media\\LowHealth.mp3", -- low health sound
	["low_mana"] = "Interface\\AddOns\\!FreeUI\\media\\LowMana.mp3", -- low mana sound
	["texture"] = "Interface\\AddOns\\!freeUI\\media\\statusbar", -- statusbar texture
	["totemborder"] = "Interface\\AddOns\\!freeUI\\media\\border", -- totem border (duh)
	["questborder"] = "Interface\\AddOns\\!freeUI\\media\\questglow", -- quest highlight border in bags + checked texture
}

FreeUI.dummy = function() end

FreeUI.CreateBD = function(f, a)
	f:SetBackdrop({
		bgFile = FreeUI.backdrop, 
		edgeFile = FreeUI.backdrop, 
		edgeSize = 1, 
	})
	f:SetBackdropColor(0, 0, 0, a or .5)
	f:SetBackdropBorderColor(0, 0, 0)
end

FreeUI.CreateSD = function(parent, size, r, g, b, alpha, offset)
	local sd = CreateFrame("Frame", nil, parent)
	sd.size = size or 5
	sd.offset = offset or 0
	sd:SetBackdrop({
		edgeFile = FreeUI.glow,
		edgeSize = sd.size,
	})
	sd:SetPoint("TOPLEFT", parent, -sd.size - 1 - sd.offset, sd.size + 1 + sd.offset)
	sd:SetPoint("BOTTOMRIGHT", parent, sd.size + 1 + sd.offset, -sd.size - 1 - sd.offset)
	sd:SetBackdropBorderColor(r or 0, g or 0, b or 0)
	sd:SetAlpha(alpha or 1)
end

FreeUI.CreateFS = function(parent, size, justify)
    local f = parent:CreateFontString(nil, "OVERLAY")
    f:SetFont(FreeUI.font, size, "OUTLINEMONOCHROME")
    f:SetShadowColor(0, 0, 0, 0)
    if(justify) then f:SetJustifyH(justify) end
    return f
end

FreeUI.CreatePulse = function(frame, speed, mult, alpha) -- pulse function originally by nightcracker
	frame.speed = speed or .05
	frame.mult = mult or 1
	frame.alpha = alpha or 1
	frame.tslu = 0 -- time since last update
	frame:SetScript("OnUpdate", function(self, elapsed)
		self.tslu = self.tslu + elapsed
		if self.tslu > self.speed then
			self.tslu = 0
			self:SetAlpha(self.alpha)
		end
		self.alpha = self.alpha - elapsed*self.mult
		if self.alpha < 0 and self.mult > 0 then
			self.mult = self.mult*-1
			self.alpha = 0
		elseif self.alpha > 1 and self.mult < 0 then
			self.mult = self.mult*-1
		end
	end)
end