local n = UnitName("player")
local lvl = UnitLevel("player")
local class = select(2, UnitClass("player"))

--[[ General config ]]

FreeUI["config"] = {
	["audio_alert"] = true, 		-- audio alert for low health/mana
	["autoroll"] = true, 			-- automatically DE or greed on BoE greens (DE priority)
	["auto_accept"] = true,			-- auto accept invites from friends and guildies
	["castbar"] = 1, 			-- 1 = dps/tank cast bar, 2 = caster/healer cast bar
	["exp_showtext"] = false, 		-- show text on exp/rep bar	
	["healmode"] = false, 			-- enable healer unitframes
	["healmode_oldstyle"] = false, 		-- old unit frame style for heal mode
	["hotkey"] = false, 			-- show hot keys on buttons
	["reminder"] = true, 			-- reminder for class buffs
	["tooltip_cursor"] = false,		-- anchor the tooltip to the cursor
}

-- [[ Character specific ]]

if n == "Amathal" then
	FreeUI.config.healmode = true
end

-- [[ Level specific ]]

if lvl ~= 80 then
	FreeUI.config.autoroll = false
end

-- [[ Class specific ]]

if class == "MAGE" or class == "PRIEST" or class == "WARLOCK" then
	FreeUI.config.castbar = 2
end

-- [[ Class modules and spells ]]

-- Class modules
FreeUI["class"] = {
	["shaman"] = true, 		-- totem bars
	["warrior_shockwave"] = true,	-- alert when on 3 stacks of thunderstruck
	["warrior_shouts"] = true, 	-- shout reminder
}

-- Selfbuff reminder
FreeUI["selfbuffs"] = {
	HUNTER = {
		13165, -- hawk
		5118, -- cheetah
		13159, -- pack
		20043, -- wild
		82661, -- fox
	},
	PALADIN = {
		20154, -- seal of righteousness
		20165, -- seal of insight
		20164, -- seal of justice
		31801, -- seal of truth
	},
	PRIEST = {
		588, -- inner fire
	},
	MAGE = {
		7302, -- frost armor
		6117, -- mage armor
		30482, -- molten armor
		86941, -- molten armor 2
	},
	WARLOCK = {
		28176, -- fel armor
		687, -- demon armor
	},
	SHAMAN = {
		52127, -- water shield
		324, -- lightning shield
		974, -- earth shield
	},
	DEATHKNIGHT = {
		57330, -- horn of Winter
		8076, -- Shaman Strength of Earth Totem
	},
}

-- sFilter buff tracker
FreeUI["sfilter"] = {
	["PALADIN"] = {
	-- Divine Plea
	{spellId = 54428, size = 39, unitId = "player", isMine = 1, filter = "HELPFUL", setPoint = {"CENTER", UIParent, "BOTTOMLEFT", 937, 350}},
	-- Divine Shield, Hand of Protection, Divine Protection, Avenging Wrath, Zealotry
	{spellId = 642, spellId2 = 1022, spellId3 = 498, spellId4 = 31884, spellId5 = 85696, size = 39, unitId = "player", isMine = "all", filter = "HELPFUL", setPoint = {"CENTER", UIParent, "BOTTOMLEFT", 840, 358}},
	-- Inquisition
	{spellId = 84963, size = 39, unitId = "player", isMine = "all", filter = "HELPFUL", setPoint = {"CENTER", UIParent, "BOTTOMLEFT", 738, 348}},
	},
	["PRIEST"] = {
	-- Chakra (_, Heal, Renew, Prayer of Healing, Smite)
	{spellId = 14751, spellId2 = 81208, spellId3 = 81207, spellId4 = 81206, spellId5 = 81209, size = 39, unitId = "player", isMine = 1, filter = "HELPFUL", setPoint = {"CENTER", UIParent, "BOTTOMLEFT", 840, 358}},
	}
}

-- [[ oUF ]]

FreeUI["debuffFilter"] = {
	["Sunder Armor"] = true,
	["Expose Armor"] = true,
	["Thunder Clap"] = true,
	["Infected Wounds"] = true,
	["Frost Fever"] = true,
	["Demoralizing Shout"] = true,
	["Demoralizing Roar"] = true,
	["Vindication"] = true,
	["Polymorph"] = true,
	["Blind"] = true,
	["Sap"] = true,
	["Kidney Shot"] = true,
	["Cheap Shot"] = true,
	["Bash"] = true,
	["Hammer of Justice"] = true,
	["Repentance"] = true,
	["Strangulate"] = true,
	["Shackle Undead"] = true,
	["Entangling Roots"] = true,
	["Cyclone"] = true,
	["Hibernate"] = true,
	["Banish"] = true,
	["Wyvern Sting"] = true,
	["Hex"] = true,
	["Taunt"] = true,
	["Challenging Shout"] = true,
	["Mocking Blow"] = true,
	["Righteous Defense"] = true,
	["Hand of Reckoning"] = true,
	["Death Grip"] = true, 
	["Dark Command"] = true,
	["Growl"] = true,
	["Challenging Roar"] = true,
}