  local bar1 = CreateFrame("Frame","rABS_MainMenuBar",UIParent, "SecureHandlerStateTemplate")
    bar1:SetWidth(518)
    bar1:SetHeight(58)
    bar1:SetPoint("BOTTOM", 21, 97)

  bar1:SetScale(.7)
  
  local Page = {
    ["DRUID"] = "[bonusbar:1,nostealth] 7; [bonusbar:1,stealth] %s; [bonusbar:2] 8; [bonusbar:3] 9; [bonusbar:4] 10;",
    ["WARRIOR"] = "[bonusbar:1] 7; [bonusbar:2] 8; [bonusbar:3] 9;",
    ["PRIEST"] = "[bonusbar:1] 7;",
    ["ROGUE"] = "[bonusbar:1] 7; [form:3] 7;",
    ["WARLOCK"] = "[form:2] 7;",
    ["DEFAULT"] = "[bar:2] 2; [bar:3] 3; [bar:4] 4; [bar:5] 5; [bar:6] 6; [bonusbar:5] 11;",
  }
  
  local function GetBar()
    local condition = Page["DEFAULT"]
    local class = select(2, UnitClass("player"))
    local page = Page[class]
    if page then
      if class == "DRUID" then
        -- Handles prowling, prowling has no real stance, so this is a hack which utilizes the Tree of Life bar for non-resto druids.
        if IsSpellKnown(33891) then -- Tree of Life form
          page = page:format(7)
        else
          page = page:format(8)
        end
      end
      condition = condition.." "..page
    end
    condition = condition.." 1"
    return condition
  end
  
  bar1:RegisterEvent("PLAYER_LOGIN")
  bar1:RegisterEvent("PLAYER_ENTERING_WORLD")
  bar1:RegisterEvent("KNOWN_CURRENCY_TYPES_UPDATE")
  bar1:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
  bar1:RegisterEvent("BAG_UPDATE")
  bar1:SetScript("OnEvent", function(self, event, ...)
    if event == "PLAYER_LOGIN" then
      local button
      for i = 1, NUM_ACTIONBAR_BUTTONS do
        button = _G["ActionButton"..i]
        self:SetFrameRef("ActionButton"..i, button)
      end  
  
      self:Execute([[
        buttons = table.new()
        for i = 1, 12 do
          table.insert(buttons, self:GetFrameRef("ActionButton"..i))
        end
      ]])
  
      self:SetAttribute("_onstate-page", [[ 
        for i, button in ipairs(buttons) do
          button:SetAttribute("actionpage", tonumber(newstate))
        end
      ]])
      
      RegisterStateDriver(self, "page", GetBar())
    elseif event == "PLAYER_ENTERING_WORLD" then
      MainMenuBar_UpdateKeyRing()
      local button
      for i = 1, 12 do
        button = _G["ActionButton"..i]
        button:ClearAllPoints()
        button:SetParent(self)
        if i == 1 then
          button:SetPoint("BOTTOMLEFT", bar1, 0,0)
        else
          local previous = _G["ActionButton"..i-1]
            button:SetPoint("LEFT", previous, "RIGHT", 1 / .7, 0)
        end
      end
    else
       MainMenuBar_OnEvent(self, event, ...)
    end
  end)

  local bar2 = CreateFrame("Frame","rABS_MultiBarBottomLeft",UIParent, "SecureHandlerStateTemplate")
    bar2:SetWidth(518)
    bar2:SetHeight(58)
    bar2:SetPoint("BOTTOM", 21, 60)
  bar2:SetScale(.7)

  MultiBarBottomLeft:SetParent(bar2)
  
  for i=1, 12 do
    local button = _G["MultiBarBottomLeftButton"..i]
    button:ClearAllPoints()
    if i == 1 then
      button:SetPoint("BOTTOMLEFT", bar2, 0,0)
    else
      local previous = _G["MultiBarBottomLeftButton"..i-1]      
        button:SetPoint("LEFT", previous, "RIGHT", 1 / .7, 0)
      
    end
  end

  local bar3 = CreateFrame("Frame","rABS_MultiBarBottomRight",UIParent, "SecureHandlerStateTemplate")
    bar3:SetWidth(518)
    bar3:SetHeight(58)
    bar3:SetPoint("BOTTOM", 21, 134)
  bar3:SetScale(.7)

  MultiBarBottomRight:SetParent(bar3)
  
  for i=1, 12 do
    local button = _G["MultiBarBottomRightButton"..i]
    button:ClearAllPoints()
    if i == 1 then
      button:SetPoint("BOTTOMLEFT", bar3, 0,0)
    else
      local previous = _G["MultiBarBottomRightButton"..i-1]      
        button:SetPoint("LEFT", previous, "RIGHT", 1 / .7, 0)
      
    end
  end

  local bar4 = CreateFrame("Frame","rABS_MultiBarRight",UIParent, "SecureHandlerStateTemplate")
  bar4:SetHeight(518)
  bar4:SetWidth(58)
  bar4:SetPoint("LEFT", 50, 0)

  bar4:SetScale(.7)

  MultiBarRight:SetParent(bar4)
  
  for i=1, 12 do
    local button = _G["MultiBarRightButton"..i]
    button:ClearAllPoints()
    if i == 1 then
      button:SetPoint("TOPLEFT", bar4, 0,0)
    else
      local previous = _G["MultiBarRightButton"..i-1]
      button:SetPoint("TOP", previous, "BOTTOM", 0, -1 / .7)
    end
  end

  local bar5 = CreateFrame("Frame","rABS_MultiBarLeft",UIParent, "SecureHandlerStateTemplate")
  bar5:SetHeight(518)
  bar5:SetWidth(58)
  bar5:SetPoint("LEFT", 87, 0)

  bar5:SetScale(.7)

  MultiBarLeft:SetParent(bar5)
  
  for i=1, 12 do
    local button = _G["MultiBarLeftButton"..i]
    button:ClearAllPoints()
    if i == 1 then
      button:SetPoint("TOPLEFT", bar5, 0,0)
    else
      local previous = _G["MultiBarLeftButton"..i-1]
      button:SetPoint("TOP", previous, "BOTTOM", 0, -1 / .7)
    end
  end

  local FramesToHide = {
    MainMenuBar, 
    MainMenuBarArtFrame, 
    BonusActionBarFrame, 
    VehicleMenuBar,
    PossessBarFrame,
  }  
  
  for _, f in pairs(FramesToHide) do
    if f:GetObjectType() == "Frame" then
      f:UnregisterAllEvents()
    end
    f:HookScript("OnShow", function(s) s:Hide(); end)
    f:Hide()
  end

    local num = NUM_PET_ACTION_SLOTS
    
    local petbar = CreateFrame("Frame","rABS_PetBar",UIParent, "SecureHandlerStateTemplate")
    petbar:SetWidth(400)
    petbar:SetHeight(54)
    petbar:SetPoint("BOTTOMRIGHT", 42, 2)
    
    PetActionBarFrame:SetParent(petbar)
    PetActionBarFrame:SetHeight(0.001)
    
    for i=1, num do
      local button = _G["PetActionButton"..i]
      local cd = _G["PetActionButton"..i.."Cooldown"]
      button:ClearAllPoints()
      if i == 1 then
        button:SetPoint("BOTTOMLEFT", petbar, 0,0)
      else
        local previous = _G["PetActionButton"..i-1]      
        button:SetPoint("LEFT", previous, "RIGHT", 1, 0)
      end
      cd:SetAllPoints(button)
    end

  local vbar = CreateFrame("Frame","rABS_VehicleExit",UIParent, "SecureHandlerStateTemplate")
  vbar:SetHeight(16)
  vbar:SetWidth(16)
  vbar:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 430, 419)

  local veb = CreateFrame("BUTTON", nil, vbar, "SecureActionButtonTemplate");
  veb:SetAllPoints(vbar)
  veb:RegisterForClicks("AnyUp")
  veb:SetNormalTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Up")
  veb:SetPushedTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down")
  veb:SetHighlightTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down")
  veb:SetScript("OnClick", function(self) VehicleExit() end)
  veb:RegisterEvent("UNIT_ENTERING_VEHICLE")
  veb:RegisterEvent("UNIT_ENTERED_VEHICLE")
  veb:RegisterEvent("UNIT_EXITING_VEHICLE")
  veb:RegisterEvent("UNIT_EXITED_VEHICLE")
  veb:SetScript("OnEvent", function(self,event,...)
    local arg1 = ...;
    if(((event=="UNIT_ENTERING_VEHICLE") or (event=="UNIT_ENTERED_VEHICLE")) and arg1 == "player") then
      veb:SetAlpha(1)
    elseif(((event=="UNIT_EXITING_VEHICLE") or (event=="UNIT_EXITED_VEHICLE")) and arg1 == "player") then
      veb:SetAlpha(0)
    end
  end)  
  veb:SetAlpha(0)