-- Combo by Evl, modified.

evl_Combo = CreateFrame("Frame", "EvlCombo")

local count = FreeUI.CreateFS(evl_Combo, 24 * UIParent:GetScale())

local onEvent = function(self, event, ...)
	self[event](self, event, ...)
end

function evl_Combo:UpdateComboPoints()
	if not UnitIsDead("target") then
		local isInVehicle = UnitHasVehicleUI("player")
		local comboPoints = GetComboPoints(isInVehicle and "vehicle" or "player", "target")
	
		count:SetText(comboPoints > 0 and comboPoints or "")
		if count:GetText()=="1" then
			count:SetTextColor(0, 1, 0)
		elseif count:GetText()=="2" then
			count:SetTextColor(.5, 1, 0)
		elseif count:GetText()=="3" then
			count:SetTextColor(1, 1, 0)
		elseif count:GetText()=="4" then
			count:SetTextColor(1, .5, 0)
		elseif count:GetText()=="5" then
			count:SetTextColor(1, 0, 0)
		end
	end
end

function evl_Combo:PLAYER_ENTERING_WORLD(event)
	self:SetPoint("TOP", UIParent, "BOTTOM", 0, 320)

	count:SetAllPoints(evl_Combo)
	count:SetJustifyH("CENTER")
end

function evl_Combo:PLAYER_TARGET_CHANGED(event)
	self:UpdateComboPoints()
end

function evl_Combo:UNIT_COMBO_POINTS(event, unit)
	if unit == "player" or unit == "vehicle" then
		self:UpdateComboPoints()
	end
end

function evl_Combo:UNIT_EXITED_VEHICLE(event, unit)
	if unit == "player" then
		self:UpdateComboPoints()
	end
end

evl_Combo:SetWidth(50)
evl_Combo:SetHeight(50)
evl_Combo:SetFrameLevel(3)
evl_Combo:SetScript("OnEvent", onEvent)
evl_Combo:RegisterEvent("PLAYER_ENTERING_WORLD")
evl_Combo:RegisterEvent("PLAYER_TARGET_CHANGED")
evl_Combo:RegisterEvent("UNIT_COMBO_POINTS")
evl_Combo:RegisterEvent("UNIT_EXITED_VEHICLE")

-- Hide Blizzards's Combo Frame
ComboFrame:UnregisterEvent("PLAYER_TARGET_CHANGED")
ComboFrame:UnregisterEvent("UNIT_COMBO_POINTS")