-- FastError by AlleyKat, modified.

local Yoffset = -76 -- "y" layout coordinate ("VERTICAL") - Zero starts from TOP-CENTER of your monitor
local Xoffset = 0 -- "x" layout coordinate ("HORIZONTAL") - Zero starts from TOP-CENTER of your monitor
local framestrata = "TOOLTIP" -- frame strata ("BACKGROUND", "LOW", "MEDIUM", "HIGH", "TOOLTIP")
local framelevel = 30 -- frame level
local holdtime = 0.52 -- hold time (seconds)
local fadeintime = 0.08 -- fadein time (seconds)
local fadeouttime = 0.16 -- fade out time (seconds)

local Error = CreateFrame("Frame")
	UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
	
--/Errors` Frame/--
local FirstErrorFrame = CreateFrame ("Frame",nil,UIParent)
	FirstErrorFrame:SetScript("OnUpdate", FadingFrame_OnUpdate)
	FirstErrorFrame.fadeInTime = fadeintime
	FirstErrorFrame.fadeOutTime = fadeouttime
	FirstErrorFrame.holdTime = holdtime
	FirstErrorFrame:Hide()
	FirstErrorFrame:SetFrameStrata(framestrata)
	FirstErrorFrame:SetFrameLevel(framelevel)
local SecondErrorFrame = CreateFrame ("Frame",nil,UIParent)
	SecondErrorFrame:SetScript("OnUpdate", FadingFrame_OnUpdate)
	SecondErrorFrame.fadeInTime = fadeintime
	SecondErrorFrame.fadeOutTime = fadeouttime
	SecondErrorFrame.holdTime = holdtime
	SecondErrorFrame:Hide()
	SecondErrorFrame:SetFrameStrata(framestrata)
	SecondErrorFrame:SetFrameLevel(framelevel)

--/Text Mess/--
local TextOne = FirstErrorFrame:CreateFontString(nil, "OVERLAY")
	TextOne:SetPoint("TOP", UIParent, Xoffset, Yoffset)
	TextOne:SetFont(FreeUI.font, 8, "OUTLINEMONOCHROME")
	TextOne:SetTextColor(1, 1, 1)
local TextTwo = SecondErrorFrame:CreateFontString(nil, "OVERLAY")
	TextTwo:SetPoint("TOP", UIParent, Xoffset, Yoffset - 8 - 1)
	TextTwo:SetFont(FreeUI.font, 8, "OUTLINEMONOCHROME")
	TextTwo:SetTextColor(1, 1, 1)

--/Alert Switch
local state = 0
FirstErrorFrame:SetScript("OnHide",function() state = 0 end)
local allertIt = function(_,_,error)
	if state == 0 then 
		TextOne:SetText(error)
		FadingFrame_Show(FirstErrorFrame)
		state = 1
	 else 
		TextTwo:SetText(error)
		FadingFrame_Show(SecondErrorFrame)
		state = 0
	 end
end
Error:RegisterEvent("UI_ERROR_MESSAGE")
Error:SetScript("OnEvent",allertIt)