local f = CreateFrame("Frame")
f:SetBackdrop({
	bgFile = FreeUI.backdrop,
	edgeFile = FreeUI.glow,
	edgeSize = 3,
	insets = {left = 3, right = 3, top = 3, bottom = 3},
})
f:SetBackdropColor(1, 0, 0)
f:SetBackdropBorderColor(1, 0, 0)
f:SetAlpha(0)
f:SetWidth(8)
f:SetHeight(8)
f:SetPoint("BOTTOMRIGHT")
f:EnableMouse(true)
f:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" then
		if IsAddOnLoaded("TinyDPS") then
			DisableAddOn("TinyDPS")
			print("TinyDPS disabled. Type /rl for the changes to apply.")
		else
			EnableAddOn("TinyDPS")
			LoadAddOn("TinyDPS")
			print("TinyDPS loaded.")
		end
	elseif button == "RightButton" then
		if IsAddOnLoaded("DBM-Core") then
			DisableAddOn("DBM-Core")
			DisableAddOn("!dbm")
			print("DBM disabled. Type /rl for the changes to apply.")
		else
			EnableAddOn("!dbm")
			EnableAddOn("DBM-Core")
			LoadAddOn("!dbm")
			LoadAddOn("DBM-Core")
			print("DBM loaded.")
		end
	end
end)

f:SetScript("OnEnter", function()
	f:SetAlpha(1)
	FreeUI.CreatePulse(f)
end)

f:SetScript("OnLeave", function()
	f:SetScript("OnUpdate", nil)
	f:SetAlpha(0)
end)