-- LynStats by Obble, modified.

local total, memory, n, totaltime, addons, entry = 0, 0, 0, 0, {}
local c = CUSTOM_CLASS_COLORS[select(2, UnitClass("player"))]
local addon = CreateFrame("Button", "LynStats", UIParent)
addon:SetPoint("BOTTOM", UIParent, 0, -1)
addon:SetHeight(20)
addon:SetWidth(80)

local function SortOrder(a, b)
	return a.memory > b.memory
end

local text

function addon:new()
	text = FreeUI.CreateFS(self, 8)

	text:SetPoint("CENTER", self)

	self:SetWidth(50)
	self:SetHeight(13)

	self:SetScript("OnUpdate", self.update)

end

local last = 0
function addon:update(elapsed)
	last = last + elapsed

	if last > 1 then
		ticktack = date("%H:%M")
		ticktack = "|c00ffffff"..ticktack.."|r"

		fps = GetFramerate()
		fps = "|c00ffffff"..floor(fps).."|r fps   "

		lag = select(3, GetNetStats())
		lag = "|c00ffffff"..lag.."|r ms   "

		last = 0

		text:SetText(fps..lag..ticktack)
		text:SetTextColor(c.r, c.g, c.b)
		self:SetWidth(text:GetStringWidth())
	end
end

local function OnEnter()
	if not InCombatLockdown() then
	collectgarbage()
	UpdateAddOnMemoryUsage()
	for i=1, GetNumAddOns() do
		memory = GetAddOnMemoryUsage(i)
		if(memory>0) then
			n = n + 1
			entry = {name = GetAddOnInfo(i), memory = memory}
			addons[n] = entry
			total = total + memory
		end
	end
	sort(addons, SortOrder)

	GameTooltip:SetOwner(Minimap, "ANCHOR_NONE")
	GameTooltip:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMLEFT", -5, 0)
	GameTooltip:AddDoubleLine("Addons", format("%.1f kb", total), c.r, c.g, c.b, 1, 1, 1)

	GameTooltip:AddLine(" ")

	for _, entry in next, addons do
		GameTooltip:AddDoubleLine(entry.name, format("%.1f kb", entry.memory), 1, 1, 1, 1, 1, 1)
	end
	GameTooltip:Show()
	end
end

local function OnLeave()
	GameTooltip:Hide()
	total, n = 0, 0
	wipe(addons)
end

addon:SetScript("OnEnter", OnEnter)
addon:SetScript("OnLeave", OnLeave)
addon:new()