-- sFilter by Shantalya, modified.

local MyUnits = {
    player = true,
    vehicle = true,
    pet = true,
}

local function sFilter_CreateFrame(data)
    local spellName, _, spellIcon = GetSpellInfo(data.spellId)
    local frame = CreateFrame("Frame", "sFilter_" .. data.unitId .. "_" .. data.spellId, UIParent)
    frame:SetWidth(data.size)
    frame:SetHeight(data.size)
    frame:SetPoint(unpack(data.setPoint))
    frame:RegisterEvent("UNIT_AURA")
    frame:RegisterEvent("PLAYER_TARGET_CHANGED")
    frame:RegisterEvent("PLAYER_ENTERING_WORLD")
    frame:SetScript("OnEvent", function(self, event, ...)
        local unit = ...
        if(data.unitId==unit or event=="PLAYER_TARGET_CHANGED" or event=="PLAYER_ENTERING_WORLD") then
            self.found = false
            self:SetAlpha(1)
            for i=1, 40 do
                local name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable = UnitAura(data.unitId, i, data.filter)
                if((data.isMine~=1 or MyUnits[caster]) and (name==GetSpellInfo(data.spellId) or (data.spellId2 and name==GetSpellInfo(data.spellId2)) or (data.spellId3 and name==GetSpellInfo(data.spellId3)) or (data.spellId4 and name==GetSpellInfo(data.spellId4)) or (data.spellId5 and name==GetSpellInfo(data.spellId5)))) then
                    self.found = true
                    self.icon:SetTexture(icon)
                    self.count:SetText(count>1 and count or "")
                    if(duration>0) then
                        self.cooldown:Show()
                        CooldownFrame_SetTimer(self.cooldown, expirationTime-duration, duration, 1)
                    else
                        self.cooldown:Hide()
                    end
                    break
                end
            end

            if(not self.found) then
                self:SetAlpha(0)
                self.icon:SetTexture(spellIcon)
                self.count:SetText("")
                self.cooldown:Hide()
            end
        end

    end)

    frame.icon = frame:CreateTexture("$parentIcon", "BACKGROUND")
    frame.icon:SetAllPoints(frame)
    frame.icon:SetTexture(spellIcon)
    frame.icon:SetTexCoord(0.08, 0.92, 0.08, 0.92)

    frame.count = FreeUI.CreateFS(frame, 8)
    frame.count:SetTextColor(.9, .9, .9)
    frame.count:SetPoint("TOP")

    frame.cooldown = CreateFrame("Cooldown", nil, frame, "CooldownFrameTemplate")
    frame.cooldown:SetPoint("TOPLEFT")
    frame.cooldown:SetPoint("BOTTOMRIGHT")
    frame.cooldown:SetReverse()

	local bg = CreateFrame ("Frame", nil, frame)
		bg:SetBackdrop({ 
		bgFile = FreeUI.backdrop, 
	})
	bg:SetBackdropColor(0, 0, 0)
	bg:SetPoint("TOPLEFT", frame, -1, 1)
	bg:SetPoint("BOTTOMRIGHT", frame, 1, -1)
	bg:SetFrameStrata("LOW")

end

local class = select(2, UnitClass("player"))
if(FreeUI.sfilter and FreeUI.sfilter[class]) then
    for index in pairs(FreeUI.sfilter) do
        if(index~=class) then
            FreeUI.sfilter[index] = nil
        end
    end
    for i=1, #FreeUI.sfilter[class], 1 do
        sFilter_CreateFrame(FreeUI.sfilter[class][i])
    end
end