local c = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
local f = CreateFrame("Frame", "FreeUI_InstallFrame", UIParent)
f:SetSize(400, 400)
f:SetPoint("CENTER")
FreeUI.CreateBD(f)
FreeUI.CreateSD(f)

local sb = CreateFrame("StatusBar", nil, f)
sb:SetStatusBarTexture(FreeUI.texture)
sb:SetMinMaxValues(0, 5)
sb:SetPoint("BOTTOM", f, "BOTTOM", 0, 60)
sb:SetHeight(20)
sb:SetWidth(f:GetWidth()-80)
sb:SetFrameStrata("HIGH")
sb:Hide()

local sbd = CreateFrame("Frame", nil, sb)
sbd:SetBackdrop({
	bgFile = FreeUI.backdrop,
	edgeFile = FreeUI.backdrop,
	edgeSize = 1,
})
sbd:SetPoint("TOPLEFT", sb, -1, 1)
sbd:SetPoint("BOTTOMRIGHT", sb, 1, -1)
sbd:SetBackdropColor(0, 0, 0, .3)
sbd:SetBackdropBorderColor(0, 0, 0)

local header = f:CreateFontString(nil, "OVERLAY")
header:SetFont("Fonts\\ARIALN.ttf", 16, "THINOUTLINE")
header:SetPoint("TOP", f, "TOP", 0, -20)

local text1 = f:CreateFontString(nil, "OVERLAY")
text1:SetJustifyH("LEFT")
text1:SetFont("Fonts\\ARIALN.ttf", 13, "THINOUTLINE")
text1:SetWidth(f:GetWidth()-40)
text1:SetPoint("TOPLEFT", f, "TOPLEFT", 20, -60)

local text2 = f:CreateFontString(nil, "OVERLAY")
text2:SetJustifyH("LEFT")
text2:SetFont("Fonts\\ARIALN.ttf", 13, "THINOUTLINE")
text2:SetWidth(f:GetWidth()-40)
text2:SetPoint("TOPLEFT", text1, "BOTTOMLEFT", 0, -20)

local text3 = f:CreateFontString(nil, "OVERLAY")
text3:SetJustifyH("LEFT")
text3:SetFont("Fonts\\ARIALN.ttf", 13, "THINOUTLINE")
text3:SetWidth(f:GetWidth()-40)
text3:SetPoint("TOPLEFT", text2, "BOTTOMLEFT", 0, -20)

local text4 = f:CreateFontString(nil, "OVERLAY")
text4:SetJustifyH("LEFT")
text4:SetFont("Fonts\\ARIALN.ttf", 13, "THINOUTLINE")
text4:SetWidth(f:GetWidth()-40)
text4:SetPoint("TOPLEFT", text3, "BOTTOMLEFT", 0, -20)

local credits = f:CreateFontString(nil, "OVERLAY")
credits:SetFont("Fonts\\ARIALN.ttf", 9, "THINOUTLINE")
credits:SetText("FreeUI by Freethinker @ Steamwheedle Cartel - EU / Haleth on wowinterface.com")
credits:SetPoint("BOTTOM", f, "BOTTOM", 0, 4)

local sbt = sb:CreateFontString(nil, "OVERLAY")
sbt:SetFont("Fonts\\ARIALN.ttf", 13, "THINOUTLINE")
sbt:SetPoint("CENTER", sb)

local option1 = CreateFrame("Button", "FreeUI_Install_Option1", f, "UIPanelButtonTemplate")
option1:SetPoint("BOTTOMLEFT", f, "BOTTOMLEFT", 20, 20)
option1:SetSize(128, 25)

local option2 = CreateFrame("Button", "FreeUI_Install_Option2", f, "UIPanelButtonTemplate")
option2:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -20, 20)
option2:SetSize(128, 25)

local close = CreateFrame("Button", "FreeUI_Install_CloseButton", f, "UIPanelCloseButton")
close:SetPoint("TOPRIGHT", f, "TOPRIGHT")
close:SetScript("OnClick", function()
	UIFrameFade(f,{
		mode = "OUT",
		timeToFade = 0.5,
		finishedFunc = function(f) f:Hide() end,
		finishedArg1 = f,
	})
	DisableAddOn("!Install")
	print("!Install closed and disabled on next reload. You can bring it back after a /rl typing /install.")
end)

local function Setup()
	SetCVar("useUiScale", 1)
	SetCVar("uiScale", 768/string.match(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)"))
	SetCVar("screenshotFormat", tga)
	SetCVar("cameraDistanceMax", 50)
	SetCVar("cameraDistanceMaxFactor", 3.4)
	SetCVar("nameplateShowFriends", 0)
	SetCVar("nameplateShowEnemies", 1)
	SetCVar("bloatthreat", 0)
	SetCVar("consolidateBuffs", 0)
	SetCVar("raidOptionIsShown", 0)
	-- SetMultisampleFormat(1)
end

local function SetupChat()
	FCF_ResetChatWindows()
	FCF_DockFrame(ChatFrame2)

	ChatFrame1:ClearAllPoints()
	ChatFrame1:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 50, 50)
	ChatFrame1:SetHeight(121)
	ChatFrame1:SetWidth(342)
	ChatFrame1:SetUserPlaced(true)

	FCF_SavePositionAndDimensions(ChatFrame1)
	FCF_SetLocked(ChatFrame1, 1)

	local channels = {
		"SAY",
		"EMOTE",
		"YELL",
		"GUILD",
		"OFFICER",
		"GUILD_ACHIEVEMENT",
		"ACHIEVEMENT",
		"WHISPER",
		"PARTY",
		"PARTY_LEADER",
		"RAID",
		"RAID_LEADER",
		"RAID_WARNING",
		"BATTLEGROUND",
		"BATTLEGROUND_LEADER",
		"CHANNEL1",
		"CHANNEL2",
		"CHANNEL3",
		"CHANNEL4",
		"CHANNEL5",
		"CHANNEL6",
		"CHANNEL7",
	}
	
	for i, v in ipairs(channels) do
		ToggleChatColorNamesByClassGroup(true, v)
	end
end

local function SetupTinyDPS()
	if(tdps) then table.wipe(tdps) end

tdps = {
	["view"] = "d",
	["maxBars"] = 10,
	["shortDamage"] = true,
	["barHeight"] = 14,
	["border"] = {
		0, -- [1]
		0, -- [2]
		0, -- [3]
		0, -- [4]
	},
	["showDPS"] = true,
	["fight"] = 1,
	["anchor"] = "TOPLEFT",
	["showPercent"] = false,
	["speed"] = 2,
	["onlyBossSegments"] = false,
	["autoReset"] = false,
	["backdrop"] = {
		0, -- [1]
		0, -- [2]
		0, -- [3]
		0, -- [4]
	},
	["swapColor"] = true,
	["showMinimapButton"] = false,
	["tooltipTargets"] = 3,
	["showDamage"] = true,
	["tooltipSpells"] = 3,
	["layout"] = 11,
	["showRank"] = false,
	["width"] = 148,
	["classColor"] = {
		["DEATHKNIGHT"] = {
			["a"] = 1,
			["r"] = 0.77,
			["g"] = 0.12,
			["b"] = 0.23,
		},
		["WARRIOR"] = {
			["a"] = 1,
			["r"] = 0.9,
			["g"] = 0.65,
			["b"] = 0.45,
		},
		["PALADIN"] = {
			["a"] = 1,
			["r"] = 1,
			["g"] = 0.22,
			["b"] = 0.52,
		},
		["MAGE"] = {
			["a"] = 1,
			["r"] = 0,
			["g"] = 0.76,
			["b"] = 1,
		},
		["PRIEST"] = {
			["a"] = 1,
			["r"] = 0.8,
			["g"] = 0.87,
			["b"] = 0.9,
		},
		["WARLOCK"] = {
			["a"] = 1,
			["r"] = 0.6,
			["g"] = 0.47,
			["b"] = 0.85,
		},
		["HUNTER"] = {
			["a"] = 1,
			["r"] = 0.58,
			["g"] = 0.86,
			["b"] = 0.49,
		},
		["SHAMAN"] = {
			["a"] = 1,
			["r"] = 0,
			["g"] = 0.6,
			["b"] = 0.6,
		},
		["DRUID"] = {
			["a"] = 1,
			["r"] = 1,
			["g"] = 0.49,
			["b"] = 0.04,
		},
		["ROGUE"] = {
			["a"] = 1,
			["r"] = 1,
			["g"] = 0.91,
			["b"] = 0.2,
		},
		["UNKNOWN"] = {
			["a"] = 1,
			["r"] = 0.63,
			["g"] = 0.58,
			["b"] = 0.24,
		},
	},
	["font"] = {
		["outline"] = "OUTLINEMONOCHROME",
		["shadow"] = 0,
		["name"] = "Interface\\AddOns\\!freeUI\\media\\Hooge0655.ttf",
		["size"] = 8,
	},
	["version"] = "0.90",
	["shortDPS"] = true,
	["barbackdrop"] = {
		1, -- [1]
		1, -- [2]
		1, -- [3]
		0, -- [4]
	},
	["hidePvP"] = true,
	["spacing"] = 1,
	["bar"] = {
		0.9, -- [1]
		0.9, -- [2]
		0.9, -- [3]
		1, -- [4]
	},
}
tdpsPosition = {
	["y"] = 473.9998779296875,
	["x"] = -787.9999771118164,
}
end

local function SetupDBM()
	if(DBM_SavedOptions) then table.wipe(DBM_SavedOptions) end

	DBM_SavedOptions = {
		["SpecialWarningFontSize"] = 50,
		["ShowWarningsInChat"] = true,
		["DontSetIcons"] = false,
		["ArrowPosX"] = 0,
		["SpecialWarningSound"] = "Sound\\Spells\\PVPFlagTaken.wav",
		["AutoRespond"] = true,
		["HealthFrameGrowUp"] = false,
		["StatusEnabled"] = true,
		["HideBossEmoteFrame"] = false,
		["ShowBigBrotherOnCombatStart"] = false,
		["BlockVersionUpdatePopup"] = true,
		["WarningColors"] = {
			{
				["b"] = 0.9411764705882353,
				["g"] = 0.8,
				["r"] = 0.4117647058823529,
			}, -- [1]
			{
				["b"] = 0,
				["g"] = 0.9490196078431372,
				["r"] = 0.9490196078431372,
			}, -- [2]
			{
				["b"] = 0,
				["g"] = 0.5019607843137255,
				["r"] = 1,
			}, -- [3]
			{
				["b"] = 0.1019607843137255,
				["g"] = 0.1019607843137255,
				["r"] = 1,
			}, -- [4]
		},
		["RangeFrameY"] = -50,
		["SpecialWarningFont"] = "Fonts\\FRIZQT__.TTF",
		["SpamBlockRaidWarning"] = true,
		["ShowFakedRaidWarnings"] = false,
		["DontSendBossAnnounces"] = false,
		["HPFrameMaxEntries"] = 5,
		["WarningIconRight"] = false,
		["RangeFramePoint"] = "CENTER",
		["SpecialWarningPoint"] = "CENTER",
		["ShowSpecialWarnings"] = true,
		["RaidWarningSound"] = "Sound\\Doodad\\BellTollNightElf.wav",
		["DontShowBossAnnounces"] = false,
		["SpecialWarningY"] = 75,
		["RangeFrameSound2"] = "none",
		["SpecialWarningX"] = 0,
		["AlwaysShowHealthFrame"] = false,
		["RaidWarningPosition"] = {
			["Y"] = -185,
			["X"] = 0,
			["Point"] = "TOP",
		},
		["HPFramePoint"] = "RIGHT",
		["Enabled"] = true,
		["RangeFrameSound1"] = "none",
		["WarningIconLeft"] = false,
		["HealthFrameWidth"] = 150,
		["RangeFrameLocked"] = false,
		["DontSendBossWhispers"] = false,
		["SpecialWarningFontColor"] = {
			0, -- [1]
			0, -- [2]
			1, -- [3]
		},
		["HPFrameY"] = -176.2242279052734,
		["HelpMessageShown"] = false,
		["RangeFrameX"] = 50,
		["ShowMinimapButton"] = false,
		["HPFrameX"] = -92.86503601074219,
		["HealthFrameLocked"] = true,
		["SpamBlockBossWhispers"] = false,
		["ArrowPosY"] = -150,
		["ArrowPoint"] = "TOP",
	}
	DBT_SavedOptions = {
		["DBM"] = {
			["EndColorG"] = 1,
			["FillUpBars"] = true,
			["HugeBarXOffset"] = 0,
			["Scale"] = 1,
			["IconLeft"] = false,
			["HugeBarYOffset"] = 0,
			["HugeWidth"] = 229,
			["BarYOffset"] = 3,
			["HugeTimerY"] = -167.9991455078125,
			["TimerX"] = 207.9999542236328,
			["ExpandUpwards"] = false,
			["TimerPoint"] = "TOPLEFT",
			["StartColorG"] = 0,
			["HugeScale"] = 1,
			["StartColorB"] = 0,
			["EndColorR"] = 0,
			["Width"] = 229,
			["HugeTimerPoint"] = "CENTER",
			["StartColorR"] = 1,
			["FontSize"] = 10,
			["HugeBarsEnabled"] = true,
			["HugeTimerX"] = -274.9999389648438,
			["TimerY"] = -79.99993133544922,
			["BarXOffset"] = 0,
			["EndColorB"] = 0,
		},
	}
end

local step5 = function()
	sb:SetValue(5)
	PlaySoundFile("Sound\\interface\\LevelUp.wav")
	header:SetText("Success!")
	text1:SetText("Installation is complete.")
	text2:SetText("Please click the 'Finish' button to reload the UI.")
	text3:SetText("")
	text4:SetText("Enjoy!")
	sbt:SetText("5/5")
	option1:Hide()
	option2:SetText("Finish")

	option2:SetScript("OnClick", function()
		DisableAddOn("!Install")
		ReloadUI()
	end)
end

local step4 = function()
	sb:SetValue(4)
	header:SetText("4. DBM")
	text1:SetText("The fourth and final step applies the DBM settings.")
	text2:SetText("This step is recommended for any user.")
	text3:SetText("")
	sbt:SetText("4/5")

	option1:SetScript("OnClick", step5)
	option2:SetScript("OnClick", function()
		SetupDBM()
		step5()
	end)
end

local step3 = function()
	sb:SetValue(3)
	header:SetText("3. TinyDPS")
	text1:SetText("The third step applies the TinyDPS settings.")
	text2:SetText("This step is recommended for any user.")
	text3:SetText("")
	sbt:SetText("3/5")

	option1:SetScript("OnClick", step4)
	option2:SetScript("OnClick", function()
		SetupTinyDPS()
		step4()
	end)
end

local step2 = function()
	sb:SetValue(2)
	header:SetText("2. Chat")
	text1:SetText("The second step applies the correct chat setup.")
	text2:SetText("If you are a new user, this step is recommended. If you are an existing user, you may want to skip this step.")
	text3:SetText("It is normal that your chat font will appear too big upon applying these settings. It will revert back to normal when finishing the installation.")
	sbt:SetText("2/5")

	option1:SetScript("OnClick", step3)
	option2:SetScript("OnClick", function()
		SetupChat()
		step3()
	end)
end

local step1 = function()
	sb:Show()
	sb:SetValue(1)
	sb:SetStatusBarColor(0.26, 1, 0.22)
	header:SetText("1. Core")
	text1:SetText("These steps will apply the correct setup for FreeUI.")
	text2:SetText("The first step applies the essential settings.")
	text3:SetText("This is recommended for any user, unless you want to apply only a specific part of the settings.")
	text4:SetText("Click 'Continue' to apply the settings, or click 'Skip' if you wish to skip this step.")
	sbt:SetText("1/5")

	option1:Show()

	option1:SetText("Skip")
	option2:SetText("Continue")

	option1:SetScript("OnClick", step2)
	option2:SetScript("OnClick", function()
		Setup()
		step2()
	end)
end

local tut5 = function()
	sb:SetValue(5)
	header:SetText("5. Finished")
	text1:SetText("The tutorial is complete. You can choose to reconsult it at any time by typing /install.")
	text2:SetText("You can now continue to install the UI.")
	text3:SetText("")
	text4:SetText("")

	sbt:SetText("5/5")

	option1:Show()

	option1:SetText("Close")
	option2:SetText("Install")

	option1:SetScript("OnClick", function()
		UIFrameFade(f,{
			mode = "OUT",
			timeToFade = 0.5,
			finishedFunc = function(f) f:Hide() end,
			finishedArg1 = f,
		})
		DisableAddOn("!Install")
		print("!Install closed and disabled on next reload. You can bring it back after a /rl typing /install.")
	end)
	option2:SetScript("OnClick", step1)
end

local tut4 = function()
	sb:SetValue(4)
	header:SetText("4. /Commands")
	text1:SetText("Lastly, FreeUI includes useful slash commands. Below is a list.")
	text2:SetText("/en and /dis are used to quickly enable and disable addons after a /rl, which is a shortened version of /console reloadui.")
	text3:SetText("/rc initiates a ready check. /rd disbands a party or raid. /bank purchase lets you purchase an additional bank bag slot. /wf locks and unlocks the watchframe for dragging.")
	text4:SetText("/gm toggles the Help frame. /install enabled and loads this installer. /gn and /gp print the name or parent of the frame below the cursor.")

	sbt:SetText("4/5")

	option2:SetScript("OnClick", tut5)
end

local tut3 = function()
	sb:SetValue(3)
	header:SetText("3. Features")
	text1:SetText("This UI includes two ways to track buffs; an embedded sFilter, to monitor buffs, and a selfbuff reminder, which will display an icon if the buff is missing while in combat.")
	text2:SetText("You can set up these buff trackers in FreeUI/scripts/options.lua. Examples are included. Selfbuffs are already set up.")
	text3:SetText("You can mark mobs by shift-clicking mobs on your screen and selecting an icon from the dropdown menu.")
	text4:SetText("Left-clicking the bottom left corner of the screen toggles the chat frame background. Right-clicking it toggles the chat menu. Left/right-clicking the bottom right corner toggles TinyDPS and DBM respectively.")

	sbt:SetText("3/5")

	option2:SetScript("OnClick", tut4)
end

local tut2 = function()
	sb:SetValue(2)
	header:SetText("2. Unitframes")
	text1:SetText("FreeUI includes an embedded version of oUF. This handles all of the unitframes on the screen, the buffs and debuffs, and the class-specific elements.")
	text2:SetText("If you play as a healer, you may want to enable healmode in FreeUI/options.lua. You can set this for a specific name, level or class only using the examples provided.")
	text3:SetText("The layout is located in FreeUI/scripts/unitframes.lua. You can edit it to your liking, for example to change the position of the frames.")
	text4:SetText("To do so, go to the line 'oUF:Factory(function(self)' and edit the first and second coordinates of the units in the spawnHelper function. The larger the first (x) coordinate, the further to the right; the larger the second (y), the higher up.")

	sbt:SetText("2/5")

	option2:SetScript("OnClick", tut3)
end

local tut1 = function()
	sb:Show()
	sb:SetValue(1)
	sb:SetStatusBarColor(0, 0.76, 1)
	header:SetText("1. Essentials")
	text1:SetText("This quick tutorial will show you some of the features in FreeUI.")
	text2:SetText("First, the essentials that you should know before you can play with this UI.")
	text3:SetText("This installer is partially character-specific. While some of the settings that will be applied later on are account-wide, you may want to run the chat script for each character.")
	text4:SetText("FreeUI features a lightweight bag modification that was originally made by Alza. To show your bags, mouseover just above the top right of your bags. To view your bank bags, mouseover the top of the bank frame. To purchase additional bank bag slots, type /bank purchase.")

	sbt:SetText("1/5")

	option1:Hide()

	option2:SetText("Next")

	option2:SetScript("OnClick", tut2)
end
	

header:SetText("Welcome")
text1:SetText("Welcome to FreeUI!")
text2:SetText("You will be guided through the installation process in a few simple steps. At each step, you can decide whether or not you want to apply or skip the presented settings.")
text3:SetText("You are also given the possibility to be shown a brief tutorial on some of the features of FreeUI.")
text4:SetText("Press the 'Tutorial' button to be guided through this small introduction, or press 'Install' to skip this step.")

option1:SetText("Tutorial")
option2:SetText("Install")

option1:SetScript("OnClick", tut1)
option2:SetScript("OnClick", step1)